QGIS Application - Bug report #6992
gui issues with QgsRasterFormatSaveOptionsWidget on Mac OSX
2013-01-14 01:46 PM - stefano campus

Status: Closed

Priority: Normal

Assignee: Etienne Tourigny

Category: GUI

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 16096
Description

initial issue was "gui issues with QgsRasterFormatSaveOptionsWidget on Mac OSX"

Clicking the help button in QgsRasterFormatSaveOptionsWidget does not bring the help dialog forward, it appears below main dialog.

Also, there is a layout artifact that shows up when the create options dialog is resized larger.

These issues do not seem to be present in linux and windows.

Related issues:
Related to QGIS Application - Bug report # 7008: qgis crashes when "help" but... Closed 2013-01-18

History

#1 - 2013-01-14 02:01 PM - Giovanni Manghi

- Category deleted (Documentation and Help)

- Target version set to Version 2.0.0

- Crashes QGIS or corrupts data changed from No to Yes

confirmed here

#2 - 2013-01-14 05:07 PM - Larry Shaffer
- Category set to GUI
- Assignee set to Etienne Tourigny

Doesn't crash here on Mac OS X 10.7.5, but does not bring the help forward.

Before clicking Help button, slide dialog away from main Options dialog. Click Help and you might see the help dialog behind the 'Edit create options'

dialog. The 'Edit create options' dialog is being shown as ApplicationModal (I think). Generating the help dialog while it's modal, may be causing the crash.
Showing the help dialog with exec() instead of show() brings it to the front, but isn't very useful as it is modal as well. Doing:
dig->show(); //non modal

dig->raise();
dig->activateWindow();

didn't help either. Basically, | think the 'Edit create options' dialog (QgsRasterFormatSaveOptionsWidget) needs to be non-modal to begin with, then it
should work.

Similar:

http://stackoverflow.com/questions/9262018/qt-window-over-modal-dialog

One solution might be to put a QgsCollapsibleGroupBox at bottom of QgsRasterFormatSaveOptionsWidget that is populated with the Help button results,
instead of trying to pop up another window.

#3 - 2013-01-14 07:07 PM - Etienne Tourigny

- Status changed from Open to Feedback

| cannot confirm either crash, nor problem reported by Larry (help dialog behind main dialog).

| am running this on Linux Mint 14 with gdal 1.10, also tested with gdal 1.9

Could reporter and Giovanni you please input their OS and ideally provide a stack trace?

Responding to Larry's suggestion to make QgsRasterFormatSaveOptionsWidget dialog non-modal, | don't think it's a good idea because all prefs dialog

are modal.

Other suggestion, to not use help dialog, is interesting, but not really practical for formats which have many options (e.g. gtiff) because it would need to be

large.
Also this whole widget is reusable, it is embedded in the raster save as dialog as well as in the options. Therefore a help button with an external dialog is
the only practical solution, because it would add more complexity to the raster save as dialog. A fix has to work in the Options as well as in the raster save

as.

A solution might be to make the help dialog modal instead of non-modal?

#4 - 2013-01-14 07:10 PM - Etienne Tourigny

Also,

can you please test the help button in the raster save as dialog? Works fine here.

#5 - 2013-01-15 07:00 AM - Etienne Tourigny

I just tested with osgeo4w (32bit) and can confirm the crash. | don't have the compiling tools setup, can someone provide a stack trace?

#6 - 2013-01-15 07:50 AM - Larry Shaffer

- File options_gdal-create-help_saveas.png added

- File options_gdal-create-help.png added

- File options_gdal-create-artifact.png added

On Mac, raster 'Save as' dialog exhibits same issue (help behind modal create options dialog). See attachments.

Making the help dialog modal does work, bringing it in front of the create options, but it is not as helpful since the user can't leave it open for reference.
http://stackoverflow.com/questions/9262018/qt-window-over-modal-dialog

However, | understand that it is important for the create options dialog to be modal to begin with.

Regarding the QgsCollapsibleGroupBox suggestion and long option sets, maybe the group box could contain a scroll area or text edit area with scroll

bar(s) that shows the help.

Lastly, there is a layout artifact that shows up when the create options dialog is resized larger. See attachment:options_gdal-create-artifact.png Not sure

what that's from.

#7 - 2013-01-15 09:20 AM - Etienne Tourigny

Larry, thanks for your input. I'm suspecting the GUI issues you have and the crash are not entirely related, but | need feedback from the others to know

where exactly the crash happens.

I do not get any of those Ul issues on linux. | do not see the artifact on linux nor windows. As long as the crash is pending | cannot investigate the other

issues on windows.

As for having the help inline, a scroll area could help certainly, but still there will be a small area to view the options, will try to see how it looks.

#8 - 2013-01-17 02:02 AM - stefano campus
- File Clipboard02.png added

After update of master version (1.9.0-165) there is no error

QGIS version

1.9.0-Master

QGIS code revision

a928d51

Compiled against Qt

4.7

Running against Qt

4.7.1

Compiled against GDAL/OGR
1.9.2

Running against GDAL/OGR
1.9.2

GEOS Version

3.36

PostgreSQL Client Version
8.3.10

SpatiaLite Version

3.0.1

QWT Version

5.2.1

PROJ.4 Version

480

QScintilla2 Version

2.6.2

This copy of QGIS writes debugging output.
#9 - 2013-01-17 02:05 AM - stefano campus
- Status changed from Feedback to Closed

#10 - 2013-01-17 09:32 AM - Etienne Tourigny

- Crashes QGIS or corrupts data changed from Yes to No

- Subject changed from qgis crashes when "help" button is selected in options-->gdal-->edit create options to gui issues with
QgsRasterFormatSaveOptionsWidget on Mac OSX

- Status changed from Closed to Reopened

- Priority changed from Severe/Regression to Normal

Great to see it's resolved, | can't see which commit resolved this...

| am also unable to update from osgeo4w at this time (some problems with my VM), so | cannot confirm it works now.

In the meantime, | am re-opening this bug (but changing subject and description), as there are a number of gui issues identified by Larry (on Mac only it

seems).

Larry - I'm not sure what to do from here, as | would prefer not to change the Ul design but rather have the help dialog appear on top.

As | don't have access to a Mac there is little | can do in terms of debugging...

initial subject was:
qgis crashes when "help" button is selected in options-->gdal-->edit create options

initial description was:
qgis crashes when "help" is selected in options-->gdal-->edit create options
it happens for every type of gdal driver options selected

see snapshot

QGIS version

1.9.0-Master

QGIS code revision
831f99a

Compiled against Qt

4.7.1

Running against Qt

4.7.1

Compiled against GDAL/OGR
1.9.2

Running against GDAL/OGR
1.9.2

GEOS Version

3.3.6

PostgreSQL Client Version
8.3.10

SpatiaLite Version

3.0.1

QWT Version

5.21

PROJ.4 Version

480
QScintilla2 Version

26.2

#11 - 2013-01-17 09:52 AM - Larry Shaffer

Etienne Tourigny wrote:

In the meantime, | am re-opening this bug (but changing subject and description), as there are a number of gui issues identified by Larry (on Mac
only it seems).

Larry - I'm not sure what to do from here, as | would prefer not to change the Ul design but rather have the help dialog appear on top.

As | don't have access to a Mac there is little | can do in terms of debugging...

| don't see any commits either that would have fixed this on Windows. ?

Concerning the Mac issue, | can just add a compile-time control statement that makes the help window exec() instead of show() only for Macs, which will

at least remedy the help-shows-behind issue, then commit the change. Though the help opens in a modal state, it would better than it is now. Thanks for

your help on this.

#12 - 2013-01-17 09:57 AM - Etienne Tourigny

Larry, that would be great. Eventually | would like to make the help better, so we could look into that on a future date.

Making it modal, although not ideal, is better than current state.

Thanks

#13 - 2013-01-17 10:46 AM - Larry Shaffer

Mac issue 'fixed' with commit commit:fed5240

#14 - 2013-01-17 12:48 PM - Etienne Tourigny

great - do you still have the artifact when resizing the dialog? If not this issue can be closed.

#15 - 2013-01-17 03:08 PM - stefano campus
sorry, but in other windows 7 pc, error still exists...
same QGIS version: 1.9.0-Master

same QGIS code revision: a928d51

i don't know...

do i have to reopen original ticket for windows?
#16 - 2013-01-18 06:46 AM - Etienne Tourigny
- Status changed from Reopened to Closed

confirmed with latest osgeo4w - other platforms are not affected.
see new bug #7008
